precision highp float;

varying vec2 textureCoordinate;

uniform float width;
uniform float scale;
uniform vec4 color;
uniform vec2 resolution;
uniform int disabled;

uniform sampler2D inputImageTexture;

void main(void) {
    vec4 source = texture2D(inputImageTexture, textureCoordinate);
    if (disabled == 1) {
        gl_FragColor = source;
        return;
    }

    float strokeRadius = width / resolution.y;
    float outerRadius = scale;
    float innerRadius = outerRadius - strokeRadius;

    vec2 uv = textureCoordinate * 2. - 1.;
    float dist = length(uv);

    float w = .75 * 2. / resolution.y;
    float outer = smoothstep(outerRadius + w, outerRadius - w, dist);
    float inner = smoothstep(innerRadius + w, innerRadius - w, dist);

    gl_FragColor = mix(source, mix(color, source, inner), outer);
}