precision mediump float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform lowp float effect;

void main() {
    vec4 image = texture2D(inputImageTexture, textureCoordinate);

    float luminance = pow((image.r + image.g + image.b) / 3.0, 1.0);
    float lumDifference = max(0.0, min(pow(3.0 * effect / luminance, 3.0), 1.0));
    vec4 lumCorrected = effect * luminance + image * (1.0 - luminance);

    gl_FragColor = lumCorrected * lumDifference + image * (1.0 - lumDifference);
}